---
- name: Configure swarm storage servers
  hosts: "{{ hosts_var | default('none') }}"
  become: true

  vars:
    clients: "{{ storage_clients | default([]) }}"
    servers: "{{ storage_servers | default([]) | reject('equalto', ansible_facts['default_ipv4']['address']) }}"

  tasks:
    - name: Update apt cache
      ansible.builtin.apt:
        update_cache: true
        cache_valid_time: 3600
      when: ansible_facts["os_family"] == "Debian"

    - name: Ensure necessary packages are installed
      ansible.builtin.package:
        name:
          - glusterfs-server
          - xfsprogs
        state: present
      notify: "restart glusterd"

    - name: Ensure directory exists for glusterfs
      ansible.builtin.file:
        path: /mnt/glusterfs/vol1/brick1/brick
        owner: root
        group: root
        mode: "0755"
        state: directory

    - name: Allow gluster nodes and clients to communicate
      community.general.ufw:
        rule: allow
        from_ip: "{{ item }}"
      loop: "{{ [clients, servers] | flatten | list }}"
      when: ansible_facts["os_family"] == "Debian"

  handlers:
    - name: Enable glusterd service
      ansible.builtin.service:
        name: glusterd
        enabled: true
        state: restarted
      listen: "restart glusterd"
